#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include "latlon.h"

#define Pi 3.1415926
#define Rearth  6378.134E3
#define G  9.988
#define Rd 8.3145  //m^2 kg m^-2 s^-2 K^-1 mol^-1

float height(float p1, float p2);

int main (int argc, char *argv[]){
  double slon,slat;
  double slon1,slat1,slon2,slat2;
  //  double rlon,rlat;
  double dlon,dlat;
  double a,b,c,cosa,sinB,az_radar;
  float dsec;
  float p1,p2,u,v,az,el;
  float ht,h_km;
  double az_rad,el_rad,clon_rad,clat_rad,calt_km;
  float ut,vt,dx,dy;

  struct MARUMI mp;

  if(argc == 8  ){
    p1  = atof(argv[1]); 
    p2 = atof(argv[2]); 
    u = atof(argv[3]); 
    v = atof(argv[4]); 
    az = atof(argv[5]); 
    el = atof(argv[6]); 
    dsec = atof(argv[7]); 
    printf("SFC   P1:%fhPa (Surfase)\n",p1);
    printf("Sonde P2:%fhPa (Current) \n",p2);
    printf("      U :%fm/s V :%fm/s  \n",u,v);
    printf("      AZ:%fdeg EL:%fdeg  \n",az,el);
  }else{
    printf("error ARGV p1(hLa)  p2(hPa)  u(m/s) v(m/s) az(deg) el(deg) sec(sec) \n");
    exit(1);
  }
  printf("\(^^)/\n");
  ht = height(p1,p2) + CALT;
  h_km = ht / 1000;

  az_rad = az * Pi / 180;
  el_rad = el * Pi / 180;
  clon_rad = CLON * Pi / 180;
  clat_rad = CLAT * Pi / 180;
  calt_km = CALT / 1000;
  sondelatlon(az_rad,el_rad,clon_rad,clat_rad,calt_km,h_km,&mp); 

  slat1 = mp.lat_rad / Pi * 180;
  slon1 = mp.lon_rad / Pi * 180;

  ut = u * dsec;
  vt = v * dsec;
  dx = ut / Rearth / cos(clat_rad) / 1000;
  dy = vt / Rearth / 1000;

  slat2 = mp.lat_rad + dy;
  slon2 = mp.lon_rad + dx;

  slat = slat2 /Pi * 180;
  slon = slon2 /Pi * 180;
  printf("      LAT2:%f LON2:%f (Prediction after %f sec) \n",slat,slon,dsec);  
  dlat = (slat - RLAT) * Pi / 180;
  dlon = (slon - RLON) * Pi / 180;
  
  b = (90 - slat) * Pi / 180;
  c = (90 - RLAT) * Pi / 180;
  cosa = cos(b)*cos(c) + sin(b)*sin(c)*cos(dlon);
  a = acos(cosa);

  sinB = sin(b) * sin(dlon) / sin(a);

  az_radar = asin(sinB) / Pi * 180;

  printf("AZ (from radar): %f (after %f sec)\n",az_radar,dsec);

  return(0);
}

    
float height(float p1, float p2){


  float dp,dz,rho;

  rho = 1.2;
  
  dp = (p2 - p1)*100;

  dz = dp / rho/G * (-1);

  printf("Height: %f (m)\n",dz);

  return(dz);
}
