#include "latlon.h"
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>


#define Pi   3.141593
#define EARTH_RADIUS_km    6.37E3
#define EFFECTIVE_RADIUS_km  (EARTH_RADIUS_km)
//#define EFFECTIVE_RADIUS_km  ((EARTH_RADIUS_km)*(1.33333))

void sondelatlon( const double az_rad, const double el_rad, double c_lon_rad, double c_lat_rad, double c_alt_km, double h_km, struct MARUMI *mp ){

  double c,c2;
  double Ld_km,r_km;
  double Sa,Sp,Sb,cosSb,sinP,sinP2;
  double tmpa,tmpb;

  tmpa = pow((EARTH_RADIUS_km+h_km),2) - pow(sin(el_rad+Pi/2),2) * pow(EARTH_RADIUS_km,2);
   tmpb = sqrt(tmpa);
	  
  // r_km = tmpb - cos(el_rad+Pi/2);
  r_km = EARTH_RADIUS_km * cos(el_rad+Pi/2) + tmpb;
  //  printf("rkm=%f hkm=%f\n",r_km,h_km);
  //  printf("el=%f az=%f\n",el_rad,az_rad);

  c = r_km * cos( el_rad ) / ( EFFECTIVE_RADIUS_km + r_km * sin( el_rad ) + c_alt_km );

  if(  fabs(c) < 1.0e-6 ) {
    mp->lat_rad = 0.0;
    mp->lon_rad = 0.0;
    //    mp->alt_km = r_km;
  }else{
    c = atan( c );
    Ld_km = c * EFFECTIVE_RADIUS_km;
    c2 = r_km * sin( el_rad ) + c_alt_km;
    //   h_km = ( EFFECTIVE_RADIUS_km + c2 ) / cos( c ) - EFFECTIVE_RADIUS_km; 

    Sa = (double)(Pi / 2) - c_lat_rad;
    Sp = Ld_km / EARTH_RADIUS_km;
    cosSb = cos(Sa)*cos(Sp) + sin(Sa)*sin(Sp)*cos(az_rad);
    Sb = acos(cosSb);
    sinP = sin(az_rad)*sin(Sp) / sin(Sb);
    sinP2 = asin(sinP);

    mp->lat_rad = Pi / 2 - Sb;
    mp->lon_rad = c_lon_rad + sinP2;
    //    mp->alt_km  = h_km;

  }
  
  return;

}
